SystemOrganization addCategory: #'OB-SUnitIntegration'!

!OBCodeBrowser methodsFor: '*ob-sunitIntegration' stamp: 'dc 8/2/2007 17:51'!
cmdSUnitIntegration
	^ {  OBCmdTestPackage. OBCmdTestClass. OBCmdTestMethod. OBCmdTestProtocol }! !

OBCommand subclass: #OBCmdSUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-SUnitIntegration'!

!OBCmdSUnit methodsFor: 'private' stamp: 'dc 8/2/2007 17:46'!
buildSuite
	self subclassResponsibility ! !

!OBCmdSUnit methodsFor: 'execution' stamp: 'alexandre@bergel.eu 9/24/2007 10:00'!
execute
	| res defectSelectors |
	res := self buildSuite run.
	res hasPassed 
		ifTrue: [self successNotification]
		ifFalse: 
			[defectSelectors := res defects collect: [:ts | ts selector].
			defectSelectors size > 2
				ifTrue: [defectSelectors := (defectSelectors copyFrom: 1 to: 2), {'...'}].
			defectSelectors := defectSelectors inject: ''
						into: [:sum :el | sum , ' ' , el asString].
			self inform: res printString , ' => ' , defectSelectors]! !

!OBCmdSUnit methodsFor: 'accessing' stamp: 'dc 7/22/2007 20:45'!
keystroke
	^ $t! !

!OBCmdSUnit methodsFor: 'accessing' stamp: 'dc 7/25/2007 16:12'!
label
	^ 'run the tests'! !

!OBCmdSUnit methodsFor: 'execution' stamp: 'dc 7/25/2007 16:13'!
successNotification
	OBInformRequest message: 'All tests pass!!'! !

OBCmdSUnit subclass: #OBCmdTestClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-SUnitIntegration'!

!OBCmdTestClass methodsFor: 'execution' stamp: 'alexandre@bergel.eu 9/17/2007 11:18'!
buildSuite
	^ target theClass suite! !

!OBCmdTestClass methodsFor: 'testing' stamp: 'dc 4/24/2007 13:38'!
isActive
	^ (target isKindOf: OBClassNode)
		and: [requestor isSelected: target]
		and: [target theClass inheritsFrom: TestCase]! !

OBCmdSUnit subclass: #OBCmdTestMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-SUnitIntegration'!

!OBCmdTestMethod methodsFor: 'execution' stamp: 'dc 7/24/2007 20:38'!
execute
	target theClass debug: target selector.
	self successNotification
! !

!OBCmdTestMethod methodsFor: 'testing' stamp: 'dc 4/24/2007 13:31'!
isActive
	^ (target isKindOf: OBMethodNode)
		and: [requestor isSelected: target]
		and: [target theClass inheritsFrom: TestCase]
		and: [target selector beginsWith: 'test']! !

OBCmdSUnit subclass: #OBCmdTestPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-SUnitIntegration'!

!OBCmdTestPackage methodsFor: 'private' stamp: 'alexandre@bergel.eu 9/24/2007 09:44'!
buildSuite
	^ target classes
		inject: TestSuite new
		into: [:suite :classNode | 
			
			(classNode theClass inheritsFrom: TestCase)
					ifTrue: [suite addTests: classNode theClass suite tests].
			suite.
			]	! !

!OBCmdTestPackage methodsFor: 'testing' stamp: 'ab 6/16/2007 10:03'!
isActive
	^ (target isKindOf: OBClassCategoryNode)
		and: [requestor isSelected: target]
		and: [target classes anySatisfy: [:cls | cls theClass inheritsFrom: TestCase]]! !

OBCmdSUnit subclass: #OBCmdTestProtocol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-SUnitIntegration'!

!OBCmdTestProtocol methodsFor: 'private' stamp: 'alexandre@bergel.eu 9/24/2007 09:55'!
buildSuite
	| selectorUnderTheCategory tests |
	selectorUnderTheCategory := target theClass organization listAtCategoryNamed: target category.
	tests := target theClass suite tests select: [:each| selectorUnderTheCategory includes: each selector].
	^ TestSuite new addTests: tests! !

!OBCmdTestProtocol methodsFor: 'testing' stamp: 'dc 8/2/2007 17:43'!
isActive
	^ (target isKindOf: OBMethodCategoryNode)
		and: [requestor isSelected: target]! !
